-- Test order_campsite_type_carousel
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_campsite_type_carousel', array['uuid', 'integer[]']);
select function_lang_is('camper', 'order_campsite_type_carousel', array['uuid', 'integer[]'], 'sql');
select function_returns('camper', 'order_campsite_type_carousel', array['uuid', 'integer[]'], 'void');
select isnt_definer('camper', 'order_campsite_type_carousel', array['uuid', 'integer[]']);
select volatility_is('camper', 'order_campsite_type_carousel', array['uuid', 'integer[]'], 'volatile');
select function_privs_are('camper', 'order_campsite_type_carousel', array ['uuid', 'integer[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_campsite_type_carousel', array ['uuid', 'integer[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_campsite_type_carousel', array ['uuid', 'integer[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_campsite_type_carousel', array ['uuid', 'integer[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_carousel_i18n cascade;
truncate campsite_type_carousel cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (4, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , (5, 1, 'text.txt', sha256('hello, world!'))
     , (6, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, max_campers, bookable_nights, active)
values (10, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '<p>A</p>', 5, '[1, 7]', true)
     , (11, 1, '9b6370f7-f941-46f2-bc6e-de455675bd0a', 3, 'Type B', '<p>B</p>', 4, '[2, 6]', false)
;

insert into campsite_type_carousel (campsite_type_id, media_id, caption)
values (10, 4, 'A caption')
     , (11, 2, '1')
     , (11, 3, '2')
     , (11, 4, '3')
     , (11, 5, '4')
     , (11, 6, '5')
;

select lives_ok(
	$$ select order_campsite_type_carousel('9b6370f7-f941-46f2-bc6e-de455675bd0a', '{4,6,5,2,3}') $$,
	'Should be able to sort campsite type slides using their ID'
);

select bag_eq(
	$$ select campsite_type_id, media_id, position from campsite_type_carousel $$,
	$$ values (10, 4, 2147483647)
	        , (11, 4, 1)
	        , (11, 6, 2)
	        , (11, 5, 3)
	        , (11, 2, 4)
	        , (11, 3, 5)
	$$,
	'Should have sorted all campsite type slides.'
);

select *
from finish();

rollback;
